'"TEEBAL" is tee network balancer, version 1.5
' using SOLVQ subroutines
' GEJB 5 January 1995

DIM SHARED xl(1), xc(2), r(2), c(2), l(1)
COMMON SHARED r1, x1, r2, x2, swr, f, q, u, v, mrhov, nc, nr, nl, deltac
COMMON SHARED prat, rs, rp, xs, xp, rof, rofn, xl, inflag, r0, fmhz
COMMON SHARED vc1, vc2, xload, xinc

DECLARE SUB setup ()
DECLARE SUB newcal ()
DECLARE SUB reactance ()
DECLARE SUB thevenin ()
DECLARE SUB serpar ()
DECLARE SUB getpower ()
DECLARE SUB printlr ()
DECLARE SUB teedez ()           ' design a tee section
DECLARE SUB teeinput ()         ' get input data for design
DECLARE SUB intro ()            ' displays introductory screen
DECLARE SUB showhelp ()         ' show the help file
DECLARE SUB printpower ()       ' print power etc.
DECLARE SUB xadjust ()          ' adjust load reactance
DECLARE SUB powerbox ()         ' Print box around power o/p
DECLARE SUB parambox ()         ' Print box around parameter i/p

 KEY(1) ON: ON KEY(1) GOSUB fun1     ' to help screen
 KEY(3) ON: ON KEY(3) GOSUB fun3     ' set deltac = .1
 KEY(4) ON: ON KEY(4) GOSUB fun4     ' set deltac = 1
 KEY(5) ON: ON KEY(5) GOSUB fun5     ' Inductance down
 KEY(6) ON: ON KEY(6) GOSUB fun6     ' Inductance up
 KEY(7) ON: ON KEY(7) GOSUB fun7     ' Load down
 KEY(8) ON: ON KEY(8) GOSUB fun8     ' load up
 KEY(10) ON: ON KEY(10) GOSUB fun10  ' print the power proportion
 KEY(11) ON: ON KEY(11) GOSUB fun11   ' uparrow
 KEY(14) ON: ON KEY(14) GOSUB fun14   ' downarrow
 KEY(12) ON: ON KEY(12) GOSUB fun12   ' leftarrow
 KEY(13) ON: ON KEY(13) GOSUB fun13   ' rightarrow

 KEY 16, CHR$(0) + CHR$(&H4F)         ' END gives restart
 KEY(16) ON: ON KEY(16) GOSUB fend


 KEY 15, CHR$(0) + CHR$(1)
 KEY(15) ON: ON KEY(15) GOSUB stopfun   ' ESC is the stopper

' extended keyboard definitions

KEY 18, CHR$(&H80) + CHR$(&H48)     ' uparrow
KEY 19, CHR$(&H80) + CHR$(&H50)     ' downarrow
KEY 20, CHR$(&H80) + CHR$(&H4B)     ' leftarrow
KEY 21, CHR$(&H80) + CHR$(&H4D)     ' rightarrow
KEY 22, CHR$(&H80) + CHR$(&H4F)     ' END
KEY 23, CHR$(&H0) + CHR$(&H2C)       ' alt f7
KEY 24, CHR$(&H0) + CHR$(&H2D)      ' alt f8
KEY 25, CHR$(&H80) + CHR$(&H47)     ' HOME

 KEY(18) ON: ON KEY(18) GOSUB fun11   ' uparrow
 KEY(19) ON: ON KEY(19) GOSUB fun14   ' speed down
 KEY(20) ON: ON KEY(20) GOSUB fun12   ' leftarrow
 KEY(21) ON: ON KEY(21) GOSUB fun13   ' rightarow
 KEY(22) ON: ON KEY(22) GOSUB fend   ' END gives restart
 KEY(23) ON: ON KEY(23) GOSUB afun7    ' decrease load reactance
 KEY(24) ON: ON KEY(24) GOSUB afun8    ' increase load reactance

CLS
inflag = 0              ' clear input flag

CALL setup              ' setup all

DO: LOOP
END

fun1: CALL showhelp: RETURN      ' show help

fun3: deltac = .1: RETURN

fun4: deltac = 1: RETURN

fun5: IF l(1) > .2 THEN l(1) = l(1) - .1: CALL printlr: CALL newcal
RETURN

fun6: l(1) = l(1) + .1: CALL printlr: CALL newcal
RETURN

fun7: IF r(2) > 1 THEN r(2) = r(2) - 1: CALL printlr
RETURN

afun7: xinc = -1: CALL xadjust
RETURN

afun8: xinc = 1: CALL xadjust
RETURN

fun8: r(2) = r(2) + 1: CALL printlr: RETURN

fun10: LOCATE 14, 5: PRINT SPACE$(30);
CALL newcal: CALL getpower: CALL printpower: RETURN


fun11: c(1) = c(1) + deltac  ' increase C1
CALL newcal
RETURN

fun14: IF c(1) > 1 THEN c(1) = c(1) - deltac
CALL newcal
RETURN

fun12:  IF c(2) > 1 THEN c(2) = c(2) - deltac
CALL newcal
RETURN

fun13: c(2) = c(2) + deltac
CALL newcal
RETURN

fend: RUN "teebal"

stopfun: SYSTEM           ' escape comes here
PRINT "               ͻ";
PRINT "                  ";
PRINT "               ͼ";

CLS

SUB getpower
' get the power dissipation
CALL reactance
rs = r(1): xs = xl(1): CALL serpar: rind = rp
rs = r(2): xs = xc(2) + xload: CALL serpar: rload = rp
ptot = 1 / rind + 1 / rload     ' proportional to total power
pind = 1 / rind                 ' power ratio
prat = pind / ptot              ' power proportion in inductor

rof = xc(1) ^ 2 / 50 + 50       ' final characteristic impedance
rofn = rof / 50                 ' normalised to 1 ohm

IF rof <= 50 OR rof <= r(2) THEN         ' check for invalid R0
        FOR kk = 1 TO 20
        LOCATE 20, 30: PRINT "R0 too low!!!";
        SOUND kk * 100, 1
        NEXT
        LOCATE 20, 30: PRINT SPACE$(15);
        EXIT SUB
END IF

vc1 = SQR(100 * (rof - 50))     ' voltage across C1
vc2 = SQR(100 * (rof - r(2))) * xc(2) / (xc(2) + xload)' and C2

END SUB

SUB intro
LOCATE 5, 1
PRINT "      ͻ";
PRINT "                  TEEBAL, version 1.50, 5 January 1996            ";
PRINT "       TEEBAL designs, balances high-pass TEE matching sections   ";
PRINT "       for transmatch use, determines power dissipated for coils  ";
PRINT "       of finite Q.                                               ";
PRINT "                                                                  ";
PRINT "                       Gary E.J. Bold, ZL1AN.                     ";
PRINT "         You can                                                  ";
PRINT "              1. Let TEEBAL design a transmatch for you           ";
PRINT "                 to investigate, or                               ";
PRINT "              2. Enter your own transmatch values.                ";
PRINT "                                                                  ";
PRINT "              Press any key to proceed.                           ";
PRINT "              Press <f1> any time for more detailed help.         ";
PRINT "      ͼ";

DO: LOOP WHILE INKEY$ = ""
CLS
END SUB

SUB newcal
' do a new calculation of SWR
CALL reactance              ' modified reactance finder

r1 = r(2): x1 = xc(2) + xload: r2 = r(1): x2 = xl(1): u = 0: v = 0 ' setup thevenin
CALL thevenin              ' do the Thevenin
x1 = x1 + xc(1)

mrhov = SQR(((r1 - 50) ^ 2 + x1 ^ 2) / ((r1 + 50) ^ 2 + x1 ^ 2))
swr = (1 + mrhov) / (1 - mrhov)           ' compute swr

LOCATE 6, 15: PRINT SPACE$(7)
LOCATE 6, 15: PRINT USING "####.#"; c(1);

LOCATE 7, 15: PRINT SPACE$(7)
LOCATE 7, 15: PRINT USING "####.#"; c(2)

LOCATE 9, 16: PRINT SPACE$(10)
LOCATE 9, 16: PRINT USING "###.####"; swr;

LOCATE 11, 15: PRINT SPACE$(15);
LOCATE 11, 15: PRINT USING "#####.#####"; r1;

LOCATE 12, 15: PRINT SPACE$(15);
LOCATE 12, 15: PRINT USING "#####.#####"; x1;

END SUB

SUB parambox
LOCATE 4, 1
PRINT "    ͻ"
PRINT "                                                           "
PRINT "                                                           "
PRINT "                                                           "
PRINT "                                                           "
PRINT "                                                           "
PRINT "                                                           "
PRINT "                                                           "
PRINT "    ͼ"

END SUB

SUB powerbox ' prints the box around the power output

LOCATE 14, 7: PRINT "ͻ";
LOCATE 15, 7: PRINT "                                  ";
LOCATE 16, 7: PRINT "                                  ";
LOCATE 17, 7: PRINT "                                  ";
LOCATE 18, 7: PRINT "                                  ";
LOCATE 19, 7: PRINT "                                  ";
LOCATE 20, 7: PRINT "                                  ";
LOCATE 21, 7: PRINT "                                  ";
LOCATE 22, 7: PRINT "ͼ";

END SUB

SUB printlr
' update values of inductance and load on screen

LOCATE 4, 20: PRINT SPACE$(6);
LOCATE 4, 20: PRINT USING "##.###"; l(1);
LOCATE 4, 60: PRINT SPACE$(5);
LOCATE 4, 60: PRINT USING "#####"; r(2);
LOCATE 5, 60: PRINT SPACE$(5);
LOCATE 5, 60: PRINT USING "#####"; xload;
r(1) = f * l(1) * .000001 / q   ' new loss resistance value

END SUB

SUB printpower ' print the power lost and other parameters

CALL powerbox

LOCATE 15, 10: PRINT "power loss, percent is ";
LOCATE 15, 34: PRINT USING "###.##"; prat * 100;
LOCATE 16, 10: PRINT "Normalised R0 is ";
LOCATE 16, 34: PRINT USING "###.##"; rofn
LOCATE 17, 10: PRINT "      True R0 is ";
LOCATE 17, 32: PRINT USING "#####.##"; rofn * 50;
LOCATE 18, 10: PRINT "For input power of 100 watts:";
LOCATE 19, 10: PRINT "Voltage across C1 is";
LOCATE 19, 34: PRINT USING "####.#"; vc1
LOCATE 20, 10: PRINT "Voltage across C2 is";
LOCATE 20, 34: PRINT USING "####.#"; vc2
LOCATE 21, 10: PRINT "min load reactance is ";
'CALL teedez:
LOCATE 21, 35: PRINT USING "####"; xc(2) + xload;
END SUB

SUB reactance ' reactance finder
     FOR I = 1 TO nc: xc(I) = -1E+12 / (c(I) * f): NEXT
     FOR I = 1 TO nl: xl(I) = l(I) * f * .000001: NEXT
END SUB

SUB serpar 'Series to parallel impedance converter
     QS = xs * xs / rs / rs: rp = rs * (1 + QS): xp = xs * (1 + 1 / QS)
END SUB

SUB setup
' sets up all
 
 nr = 2: nl = 1: nc = 2
 deltac = 1
 CALL intro                 ' display the startup screen

 PRINT : PRINT :
 PRINT "      ͻ"
 PRINT "               Parameter initialisation:                      "
 PRINT "       Shall I DESIGN the tee section for you?  (y or n)      "
 PRINT "      ͼ"
 LOCATE 5, 60: INPUT "", q$
 IF q$ <> "n" THEN
        inflag = 1              ' setup for design
        CALL teeinput           ' do the design

 END IF

 IF inflag = 0 THEN          ' bypass input if tee designed already
        CLS
        CALL parambox
        LOCATE 5, 7
        INPUT "start value, input cap? (pf)   ", c(1)
           IF c(1) = 0 THEN c(1) = 100
        LOCATE 6, 7
        INPUT "Start value, output cap? (pf)  ", c(2)
          IF c(2) = 0 THEN c(2) = 100
          LOCATE 7, 7
          DO: INPUT "Inductance? (uH)               ", l(1)
           LOOP WHILE l(1) = 0

        LOCATE 8, 7
        INPUT "Q of inductor?                 ", q
           IF q = 0 THEN q = 1000000!
        LOCATE 9, 7
        DO: INPUT "Load resistance?               ", r(2)
           LOOP WHILE r(2) = 0

        LOCATE 10, 7
        INPUT "load reactance? (signed)       ", xload
        LOCATE 11, 7
        DO: INPUT "Frequency? (MHz)               ", f
           LOOP WHILE f = 0

        fmhz = f                     ' remember frequency in MHz
        f = f * 1000000!
        f = 6.28318 * f                 ' convert to radian/sec
        r(1) = f * l(1) * .000001 / q   ' get inductor loss resistance
        CALL reactance: r0 = 50 + xc(1) ^ 2 / 50
END IF
         
CLS
LOCATE 3, 1
PRINT "      ͻ  ͻ";
PRINT "        Inductor =       uH, Q =                Load R =        Ohm  ";
PRINT "                                                Load X =        Ohm ";
PRINT "        C1 =        pF                       Frequency =        MHz ";
PRINT "        C2 =        pF                      ͼ";
PRINT "                                          ";
PRINT "        SWR =                             ";
PRINT "                                          ";
PRINT "        Rin =                             ";
PRINT "        Xin =                             ";
PRINT "      ͼ";

LOCATE 4, 20: PRINT USING "##.###"; l(1);
LOCATE 4, 34: PRINT USING "####"; q
LOCATE 4, 60: PRINT USING "#####"; r(2);
LOCATE 5, 60: PRINT USING "#####"; xload;
LOCATE 6, 60: PRINT USING "###.##"; fmhz;

LOCATE 8, 47: PRINT "ͻ";
LOCATE 9, 47: PRINT "     Arrow keys:       ";
LOCATE 10, 47: PRINT " left/right C2 down/up ";
LOCATE 11, 47: PRINT " down/up    C1 down/up ";
LOCATE 12, 47: PRINT "                       ";
LOCATE 13, 47: PRINT "    Function keys:     ";
LOCATE 14, 47: PRINT " F1    Help            ";
LOCATE 15, 47: PRINT " F3,f4 DeltaC = .1,1   ";
LOCATE 16, 47: PRINT " f5,f6 L down/up       ";
LOCATE 17, 47: PRINT " f7,f8 Load R down/up  ";
LOCATE 18, 47: PRINT " Z,X   Load X down/up  ";
LOCATE 19, 47: PRINT " F10   Show loss, R0   ";
LOCATE 20, 47: PRINT " ESC   Stop            ";
LOCATE 21, 47: PRINT " END   Restart         ";
LOCATE 22, 47: PRINT "ͼ";
'CALL teedez:
CALL newcal

END SUB

SUB showhelp

 ' read associated .doc file
 FILE$ = "teebal.doc"
 CLS

  OPEN FILE$ FOR INPUT AS #2
helplab1:  'OUTER LOOP BRANCH POINT
        X = 1: CLS :  'line count
helplab2: '     INNER LOOP BRANCH POINT
                LINE INPUT #2, T$
                PRINT T$
                X = X + 1
        IF (X <= 22) AND NOT (EOF(2)) THEN GOTO helplab2
 PRINT TAB(15); : COLOR 0, 15: PRINT "press any key to continue  or  Q to restart program"
       q$ = INKEY$: IF q$ = "q" THEN GOTO helpend
 '      INNERMOST LOOP BRANCH POINT
helplab3:         COLOR 7, 0: k$ = INKEY$
                  IF k$ = "q" OR k$ = "Q" THEN GOTO helpend 'exit loop on Q
                  IF k$ = "" THEN GOTO helplab3
 IF NOT (EOF(2)) GOTO helplab1 ' loop if not end of file

helpend: CLOSE 2: RUN "teebal.exe"
END SUB

SUB teedez
' design a tee match
' assumes r0, r(2), xload, f, passed as globals.
' finds c(1), c(2), l(1), the tee section elements

xc1 = SQR(50 * (r0 - 50))
xc2 = SQR(r(2) * (r0 - r(2)))
xl1 = 50 * r0 / xc1
xl2 = r(2) * r0 / xc2
xc2 = xc2 + xload               ' adjust for load reactance
xl = xl1 * xl2 / (xl1 + xl2)
c(1) = 1E+12 / (f * xc1)        ' f is actually omega
c(2) = 1E+12 / (f * xc2)        ' convert Cs to pF,
l(1) = xl * 1000000! / f        ' L to uH

END SUB

SUB teeinput
'  get the inputs for a tee design.

CLS
CALL parambox
LOCATE 5, 7
DO: INPUT "Load resistance, ohms? (un-normalised) ", r(2)
LOOP UNTIL r(2) <> 0

LOCATE 6, 7
INPUT "Load reactance? (signed, ohms) ", xload
LOCATE 7, 7
DO
rloop: INPUT "Characteristic impedance, ohms?  (un-normalised) ", r0
       LOOP WHILE r0 = 0

       IF xload < 0 THEN
        rt = xload ^ 2 / r(2) + r(2)    ' min value of R0 required
        IF r0 < rt THEN
                BEEP: LOCATE 15, 1: PRINT "R0 must be larger than";
                LOCATE 15, 25: PRINT USING "#####.#"; rt
                LOCATE 15, 35: PRINT "Enter another value:";
                LOCATE 7, 1: PRINT SPACE$(70): LOCATE 7, 1
         END IF
        END IF
IF r0 < rt THEN GOTO rloop

LOCATE 8, 7
INPUT "Frequency, MHz?  ", fmhz
IF fmhz = 0 THEN fmhz = 3.5

LOCATE 9, 7
INPUT "Q of inductor?  ", q
IF q = 0 THEN q = 100

f = fmhz * 6283180!                     ' convert f to omega

CALL teedez                             ' design the tee

r(1) = xl / q                          ' get the loss resistance

END SUB

SUB thevenin 'Thevenin transformer
     RD = r1 + r2: XD = x1 + x2: DD = RD * RD + XD * XD
     rt = (r2 * RD + x2 * XD) / DD: XT = (x2 * RD - r2 * XD) / DD
     R1S = r1: US = u: r1 = r1 * rt - x1 * XT: x1 = R1S * XT + x1 * rt
     u = u * rt - v * XT: v = US * XT + v * rt
END SUB

SUB xadjust
' adjust load reactace
xload = xload + xinc
xxc = 1E+12 / (f * c(2)) + xinc
c(2) = 1E+12 / (f * xxc)
CALL newcal
CALL printlr

END SUB

